Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limitd_me.F90	(revision 3938)
@@ -28,4 +28,8 @@
    USE wrk_nemo         ! work arrays
    USE prtctl           ! Print control
+  ! Check budget (Rousset)
+   USE iom              ! I/O manager
+   USE lib_fortran     ! glob_sum
+   USE limdiahsb
 
    IMPLICIT NONE
@@ -50,5 +54,4 @@
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   athorn   ! participation function; fraction of ridging/
    !                                                           !  closing associated w/ category n
-
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hrmin    ! minimum ridge thickness
    REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hrmax    ! maximum ridge thickness
@@ -138,7 +141,12 @@
       REAL(wp), POINTER, DIMENSION(:,:) ::   esnow_mlt       ! energy needed to melt snow in ocean (J m-2)
       REAL(wp), POINTER, DIMENSION(:,:) ::   vt_i_init, vt_i_final  !  ice volume summed over categories
+      REAL(wp) :: zchk_v_i, zchk_smv, zchk_fs, zchk_fw, zchk_v_i_b, zchk_smv_b, zchk_fs_b, zchk_fw_b ! Check conservation (C Rousset)
+      ! mass and salt flux (clem)
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zviold, zvsold, zsmvold   ! old ice volume...
       !!-----------------------------------------------------------------------------
 
       CALL wrk_alloc( jpi, jpj, closing_net, divu_adv, opning, closing_gross, msnow_mlt, esnow_mlt, vt_i_init, vt_i_final )
+
+      CALL wrk_alloc( jpi, jpj, jpl, zviold, zvsold, zsmvold )   ! clem
 
       IF( numit == nstart  )   CALL lim_itd_me_init   ! Initialization (first time-step only)
@@ -148,4 +156,21 @@
          CALL prt_ctl(tab2d_1=divu_i, clinfo1=' lim_itd_me: divu_i : ', tab2d_2=delta_i, clinfo2=' delta_i : ')
       ENDIF
+
+      IF( ln_limdyn ) THEN          !   Start ridging and rafting   !
+      ! -------------------------------
+      !- check conservation (C Rousset)
+      IF (ln_limdiahsb) THEN
+         zchk_v_i_b = glob_sum( SUM(   v_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) )
+         zchk_smv_b = glob_sum( SUM( smv_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) )
+         zchk_fw_b  = glob_sum( rdmicif(:,:) * area(:,:) * tms(:,:) )
+         zchk_fs_b  = glob_sum( ( fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ) * area(:,:) * tms(:,:) )
+      ENDIF
+      !- check conservation (C Rousset)
+      ! -------------------------------
+
+      ! mass and salt flux init (clem)
+      zviold(:,:,:) = v_i(:,:,:)
+      zvsold(:,:,:) = v_s(:,:,:)
+      zsmvold(:,:,:) = smv_i(:,:,:)
 
       !-----------------------------------------------------------------------------!
@@ -201,5 +226,5 @@
             ! to give asum = 1.0 after ridging.
 
-            divu_adv(ji,jj) = ( 1._wp - asum(ji,jj) ) / rdt_ice  ! asum found in ridgeprep
+            divu_adv(ji,jj) = ( amax - asum(ji,jj) ) / rdt_ice  ! asum found in ridgeprep
 
             IF( divu_adv(ji,jj) < 0._wp )   closing_net(ji,jj) = MAX( closing_net(ji,jj), -divu_adv(ji,jj) )
@@ -286,10 +311,10 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               IF (ABS(asum(ji,jj) - 1.0) .LT. epsi11) THEN
+               IF (ABS(asum(ji,jj) - amax ) .LT. epsi11) THEN
                   closing_net(ji,jj) = 0._wp
                   opning     (ji,jj) = 0._wp
                ELSE
                   iterate_ridging    = 1
-                  divu_adv   (ji,jj) = (1._wp - asum(ji,jj)) / rdt_ice
+                  divu_adv   (ji,jj) = ( amax - asum(ji,jj) ) / rdt_ice
                   closing_net(ji,jj) = MAX( 0._wp, -divu_adv(ji,jj) )
                   opning     (ji,jj) = MAX( 0._wp,  divu_adv(ji,jj) )
@@ -330,5 +355,5 @@
          DO ji = 1, jpi
 
-            IF (ABS(asum(ji,jj) - 1.0) .GT. epsi11) asum_error = .true.
+            IF (ABS(asum(ji,jj) - amax) .GT. epsi11) asum_error = .true.
 
             dardg1dt(ji,jj) = dardg1dt(ji,jj) * dti
@@ -349,5 +374,5 @@
       DO jj = 1, jpj
          DO ji = 1, jpi
-            IF (ABS(asum(ji,jj) - 1.0) .GT. epsi11) THEN ! there is a bug
+            IF (ABS(asum(ji,jj) - amax) .GT. epsi11) THEN ! there is a bug
                WRITE(numout,*) ' '
                WRITE(numout,*) ' ALERTE : Ridging error: total area = ', asum(ji,jj)
@@ -377,4 +402,18 @@
       CALL lim_var_glo2eqv
       CALL lim_itd_me_zapsmall
+
+      !--------------------------------
+      ! Update mass/salt fluxes (clem)
+      !--------------------------------
+      DO jl = 1, jpl
+         DO jj = 1, jpj 
+            DO ji = 1, jpi
+               diag_dyn_gr(ji,jj) = diag_dyn_gr(ji,jj) + ( v_i(ji,jj,jl) - zviold(ji,jj,jl) ) / rdt_ice
+               rdmicif(ji,jj) = rdmicif(ji,jj) + ( v_i(ji,jj,jl) - zviold(ji,jj,jl) ) * rhoic 
+               rdmsnif(ji,jj) = rdmsnif(ji,jj) + ( v_s(ji,jj,jl) - zvsold(ji,jj,jl) ) * rhosn 
+               fsalt_rpo(ji,jj) = fsalt_rpo(ji,jj) - ( smv_i(ji,jj,jl) - zsmvold(ji,jj,jl) ) * rhoic / rdt_ice 
+            END DO
+         END DO
+      END DO
 
       !-----------------
@@ -425,8 +464,27 @@
       ENDIF
 
+      ! -------------------------------
+      !- check conservation (C Rousset)
+      IF (ln_limdiahsb) THEN
+         zchk_fs  = glob_sum( ( fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ) * area(:,:) * tms(:,:) ) - zchk_fs_b
+         zchk_fw  = glob_sum( rdmicif(:,:) * area(:,:) * tms(:,:) ) - zchk_fw_b
+ 
+         zchk_v_i = ( glob_sum( SUM(   v_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) ) - zchk_v_i_b - ( zchk_fw / rhoic ) ) / rdt_ice
+         zchk_smv = ( glob_sum( SUM( smv_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) ) - zchk_smv_b ) / rdt_ice + ( zchk_fs / rhoic )
+
+         IF(lwp) THEN
+            IF (    ABS( zchk_v_i   ) >  1.e-5 ) WRITE(numout,*) 'violation volume [m3/day]     (limitd_me) = ',(zchk_v_i * 86400.)
+            IF (    ABS( zchk_smv   ) >  1.e-4 ) WRITE(numout,*) 'violation saline [psu*m3/day] (limitd_me) = ',(zchk_smv * 86400.)
+            IF ( MINVAL( v_i(:,:,:) ) <  0.    ) WRITE(numout,*) 'violation v_i<0  [mm]         (limitd_me) = ',(MINVAL(v_i) * 1.e-3)
+            IF ( MAXVAL( SUM(a_i(:,:,:),dim=3) ) > amax+epsi10 ) WRITE(numout,*) 'violation a_i>amax            (limitd_me) = ',MAXVAL(SUM(a_i,dim=3))
+            IF ( MINVAL( a_i(:,:,:) ) <  0.    ) WRITE(numout,*) 'violation a_i<0               (limitd_me) = ',MINVAL(a_i)
+         ENDIF
+      ENDIF
+      !- check conservation (C Rousset)
+      ! -------------------------------
+
       !-------------------------!
       ! Back to initial values
       !-------------------------!
-
       ! update of fields will be made later in lim update
       u_ice(:,:)    = old_u_ice(:,:)
@@ -439,5 +497,4 @@
       oa_i(:,:,:)   = old_oa_i(:,:,:)
       IF(  num_sal == 2  .OR.  num_sal == 4  )   smv_i(:,:,:)  = old_smv_i(:,:,:)
-
       !----------------------------------------------------!
       ! Advection of ice in a free cell, newly ridged ice
@@ -448,41 +505,46 @@
 
       ! heat content has to be corrected before ice volume
-      DO jl = 1, jpl
-         DO jk = 1, nlay_i
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  IF ( ( old_v_i(ji,jj,jl) < epsi06 ) .AND. &
-                     ( d_v_i_trp(ji,jj,jl) > epsi06 ) ) THEN
-                     old_e_i(ji,jj,jk,jl)   = d_e_i_trp(ji,jj,jk,jl)
-                     d_e_i_trp(ji,jj,jk,jl) = 0._wp
-                  ENDIF
-               END DO
-            END DO
-         END DO
-      END DO
-
-      DO jl = 1, jpl
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               IF ( ( old_v_i(ji,jj,jl) < epsi06 ) .AND. &
-                  ( d_v_i_trp(ji,jj,jl) > epsi06 ) ) THEN
-                  old_v_i(ji,jj,jl)     = d_v_i_trp(ji,jj,jl)
-                  d_v_i_trp(ji,jj,jl)   = 0._wp
-                  old_a_i(ji,jj,jl)     = d_a_i_trp(ji,jj,jl)
-                  d_a_i_trp(ji,jj,jl)   = 0._wp
-                  old_v_s(ji,jj,jl)     = d_v_s_trp(ji,jj,jl)
-                  d_v_s_trp(ji,jj,jl)   = 0._wp
-                  old_e_s(ji,jj,1,jl)   = d_e_s_trp(ji,jj,1,jl)
-                  d_e_s_trp(ji,jj,1,jl) = 0._wp
-                  old_oa_i(ji,jj,jl)    = d_oa_i_trp(ji,jj,jl)
-                  d_oa_i_trp(ji,jj,jl)  = 0._wp
-                  IF(  num_sal == 2  .OR.  num_sal == 4  )   old_smv_i(ji,jj,jl)   = d_smv_i_trp(ji,jj,jl)
-                  d_smv_i_trp(ji,jj,jl) = 0._wp
-               ENDIF
-            END DO
-         END DO
-      END DO
-
+!clem@order
+!      DO jl = 1, jpl
+!         DO jk = 1, nlay_i
+!            DO jj = 1, jpj
+!               DO ji = 1, jpi
+!                  IF ( ( old_v_i(ji,jj,jl) < epsi06 ) .AND. &
+!                     ( d_v_i_trp(ji,jj,jl) > epsi06 ) ) THEN
+!                     old_e_i(ji,jj,jk,jl)   = d_e_i_trp(ji,jj,jk,jl)
+!                     d_e_i_trp(ji,jj,jk,jl) = 0._wp
+!                  ENDIF
+!               END DO
+!            END DO
+!         END DO
+!      END DO
+!
+!      DO jl = 1, jpl
+!         DO jj = 1, jpj
+!            DO ji = 1, jpi
+!               IF ( ( old_v_i(ji,jj,jl) < epsi06 ) .AND. &
+!                  ( d_v_i_trp(ji,jj,jl) > epsi06 ) ) THEN
+!                  old_v_i(ji,jj,jl)     = d_v_i_trp(ji,jj,jl)
+!                  d_v_i_trp(ji,jj,jl)   = 0._wp
+!                  old_a_i(ji,jj,jl)     = d_a_i_trp(ji,jj,jl)
+!                  d_a_i_trp(ji,jj,jl)   = 0._wp
+!                  old_v_s(ji,jj,jl)     = d_v_s_trp(ji,jj,jl)
+!                  d_v_s_trp(ji,jj,jl)   = 0._wp
+!                  old_e_s(ji,jj,1,jl)   = d_e_s_trp(ji,jj,1,jl)
+!                  d_e_s_trp(ji,jj,1,jl) = 0._wp
+!                  old_oa_i(ji,jj,jl)    = d_oa_i_trp(ji,jj,jl)
+!                  d_oa_i_trp(ji,jj,jl)  = 0._wp
+!                  IF(  num_sal == 2  .OR.  num_sal == 4  )   old_smv_i(ji,jj,jl)   = d_smv_i_trp(ji,jj,jl)
+!                  d_smv_i_trp(ji,jj,jl) = 0._wp
+!               ENDIF
+!            END DO
+!         END DO
+!      END DO
+!clem@order
+      ENDIF  ! ln_limdyn=.true.
+      !
       CALL wrk_dealloc( jpi, jpj, closing_net, divu_adv, opning, closing_gross, msnow_mlt, esnow_mlt, vt_i_init, vt_i_final )
+      !
+      CALL wrk_dealloc( jpi, jpj, jpl, zviold, zvsold, zsmvold )   ! clem
       !
    END SUBROUTINE lim_itd_me
@@ -1086,13 +1148,13 @@
             afrft(ji,jj) = arft1(ji,jj) / aicen_init(ji,jj,jl1) !rafting
 
-            IF (afrac(ji,jj) > 1.0 + epsi11) THEN  !riging
+            IF (afrac(ji,jj) > amax + epsi11) THEN  !riging
                large_afrac = .true.
-            ELSEIF (afrac(ji,jj) > 1.0) THEN  ! roundoff error
-               afrac(ji,jj) = 1.0
+            ELSEIF (afrac(ji,jj) > amax) THEN  ! roundoff error
+               afrac(ji,jj) = amax
             ENDIF
-            IF (afrft(ji,jj) > 1.0 + epsi11) THEN !rafting
+            IF (afrft(ji,jj) > amax + epsi11) THEN !rafting
                large_afrft = .true.
-            ELSEIF (afrft(ji,jj) > 1.0) THEN  ! roundoff error
-               afrft(ji,jj) = 1.0
+            ELSEIF (afrft(ji,jj) > amax) THEN  ! roundoff error
+               afrft(ji,jj) = amax
             ENDIF
 
@@ -1137,5 +1199,7 @@
             
             !                                                             ! excess of salt is flushed into the ocean
-            fsalt_rpo(ji,jj) = fsalt_rpo(ji,jj) + ( zsrdg2 - srdg2(ji,jj) ) * rhoic / rdt_ice
+            !fsalt_rpo(ji,jj) = fsalt_rpo(ji,jj) + ( zsrdg2 - srdg2(ji,jj) ) * rhoic / rdt_ice
+
+            !rdmicif(ji,jj) = rdmicif(ji,jj) + vsw(ji,jj) * rhoic    ! gurvan: increase in ice volume du to seawater frozen in voids             
 
             !------------------------------------            
@@ -1148,5 +1212,5 @@
             dardg1dt   (ji,jj) = dardg1dt(ji,jj) + ardg1(ji,jj) + arft1(ji,jj)
             dardg2dt   (ji,jj) = dardg2dt(ji,jj) + ardg2(ji,jj) + arft2(ji,jj)
-            diag_dyn_gr(ji,jj) = diag_dyn_gr(ji,jj) + ( vrdg2(ji,jj) + virft(ji,jj) ) / rdt_ice
+            !clem diag_dyn_gr(ji,jj) = diag_dyn_gr(ji,jj) + ( vrdg2(ji,jj) + virft(ji,jj) ) / rdt_ice
             opening    (ji,jj) = opening (ji,jj) + opning(ji,jj)*rdt_ice
 
@@ -1217,5 +1281,5 @@
 
                ! Mutliply by ice volume, and divide by number of layers to get heat content in 10^9 J
-               ersw (ji,jj,jk)  = ersw(ji,jj,jk) * area(ji,jj) * vsw(ji,jj) / nlay_i
+               ersw (ji,jj,jk)  = ersw(ji,jj,jk) * area(ji,jj) * vsw(ji,jj) / REAL( nlay_i )
 
                erdg2(ji,jj,jk)  = erdg1(ji,jj,jk) + ersw(ji,jj,jk)
@@ -1240,5 +1304,5 @@
                ji = indxi(ij)
                jj = indxj(ij)
-               IF( afrac(ji,jj) > 1.0 + epsi11 ) THEN 
+               IF( afrac(ji,jj) > amax + epsi11 ) THEN 
                   WRITE(numout,*) ''
                   WRITE(numout,*) ' ardg > a_i'
@@ -1252,5 +1316,5 @@
                ji = indxi(ij)
                jj = indxj(ij)
-               IF( afrft(ji,jj) > 1.0 + epsi11 ) THEN 
+               IF( afrft(ji,jj) > amax + epsi11 ) THEN 
                   WRITE(numout,*) ''
                   WRITE(numout,*) ' arft > a_i'
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limitd_th.F90	(revision 3938)
@@ -34,4 +34,5 @@
    USE lib_mpp          ! MPP library
    USE wrk_nemo         ! work arrays
+   USE lib_fortran      ! to use key_nosignedzero
 
    IMPLICIT NONE
@@ -44,7 +45,7 @@
    PUBLIC   lim_itd_shiftice
 
-   REAL(wp) ::   epsi20 = 1e-20_wp   ! constant values
-   REAL(wp) ::   epsi13 = 1e-13_wp   !
-   REAL(wp) ::   epsi10 = 1e-10_wp   !
+   REAL(wp) ::   epsi20 = 1.e-20_wp   ! constant values
+   REAL(wp) ::   epsi13 = 1.e-13_wp   !
+   REAL(wp) ::   epsi10 = 1.e-10_wp   !
 
    !!----------------------------------------------------------------------
@@ -66,6 +67,16 @@
       !
       INTEGER ::   jl, ja, jm, jbnd1, jbnd2   ! ice types    dummy loop index         
-
-      !!------------------------------------------------------------------
+      REAL(wp) :: zchk_v_i, zchk_smv, zchk_fs, zchk_fw, zchk_v_i_b, zchk_smv_b, zchk_fs_b, zchk_fw_b ! Check conservation (C Rousset)
+      !!------------------------------------------------------------------
+      ! -------------------------------
+      !- check conservation (C Rousset)
+      IF (ln_limdiahsb) THEN
+         zchk_v_i_b = glob_sum( SUM(   v_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) )
+         zchk_smv_b = glob_sum( SUM( smv_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) )
+         zchk_fw_b  = glob_sum( rdmicif(:,:) * area(:,:) * tms(:,:) )
+         zchk_fs_b  = glob_sum( ( fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ) * area(:,:) * tms(:,:) )
+      ENDIF
+      !- check conservation (C Rousset)
+      ! -------------------------------
 
       IF( kt == nit000 .AND. lwp ) THEN
@@ -106,7 +117,10 @@
       d_e_s_thd(:,:,:,:) = e_s(:,:,:,:) - old_e_s(:,:,:,:) 
       d_e_i_thd(:,:,:,:) = e_i(:,:,:,:) - old_e_i(:,:,:,:)
-
+      !?? d_oa_i_thd(:,:,:)  = oa_i (:,:,:) - old_oa_i (:,:,:)
       d_smv_i_thd(:,:,:) = 0._wp
       IF( num_sal == 2 .OR. num_sal == 4 )   d_smv_i_thd(:,:,:) = smv_i(:,:,:) - old_smv_i(:,:,:)
+
+      ! diag only (clem)
+      dv_dt_thd(:,:,:) = d_v_i_thd(:,:,:) / rdt_ice * 86400.0
 
       IF(ln_ctl) THEN   ! Control print
@@ -141,5 +155,24 @@
          END DO
       ENDIF
-
+      !
+      ! -------------------------------
+      !- check conservation (C Rousset)
+      IF (ln_limdiahsb) THEN
+         zchk_fs  = glob_sum( ( fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ) * area(:,:) * tms(:,:) ) - zchk_fs_b
+         zchk_fw  = glob_sum( rdmicif(:,:) * area(:,:) * tms(:,:) ) - zchk_fw_b
+ 
+         zchk_v_i = ( glob_sum( SUM(   v_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) ) - zchk_v_i_b - ( zchk_fw / rhoic ) ) / rdt_ice
+         zchk_smv = ( glob_sum( SUM( smv_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) ) - zchk_smv_b ) / rdt_ice + ( zchk_fs / rhoic )
+
+         IF(lwp) THEN
+            IF (    ABS( zchk_v_i   ) >  1.e-5 ) WRITE(numout,*) 'violation volume [m3/day]     (limitd_th) = ',(zchk_v_i * 86400.)
+            IF (    ABS( zchk_smv   ) >  1.e-4 ) WRITE(numout,*) 'violation saline [psu*m3/day] (limitd_th) = ',(zchk_smv * 86400.)
+            IF ( MINVAL( v_i(:,:,:) ) <  0.    ) WRITE(numout,*) 'violation v_i<0  [mm]         (limitd_th) = ',(MINVAL(v_i) * 1.e-3)
+            IF ( MAXVAL( SUM(a_i(:,:,:),dim=3) ) >  amax+epsi10 ) WRITE(numout,*) 'violation a_i>amax    (limitd_th) = ',MAXVAL(SUM(a_i,dim=3))
+         ENDIF
+       ENDIF
+      !- check conservation (C Rousset)
+      ! -------------------------------
+      !
       !- Recover Old values
       a_i(:,:,:)   = old_a_i (:,:,:)
@@ -148,5 +181,5 @@
       e_s(:,:,:,:) = old_e_s (:,:,:,:)
       e_i(:,:,:,:) = old_e_i (:,:,:,:)
-      !
+      !?? oa_i(:,:,:)  = old_oa_i(:,:,:)
       IF( num_sal == 2 .OR. num_sal == 4 )   smv_i(:,:,:)       = old_smv_i (:,:,:)
       !
@@ -239,7 +272,7 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zindb             = 1.0-MAX(0.0,SIGN(1.0,-a_i(ji,jj,jl)))     !0 if no ice and 1 if yes
+               zindb             = 1.0-MAX(0.0,SIGN(1.0,-a_i(ji,jj,jl)+epsi10))     !0 if no ice and 1 if yes
                ht_i(ji,jj,jl)    = v_i(ji,jj,jl) / MAX(a_i(ji,jj,jl),epsi10) * zindb
-               zindb             = 1.0-MAX(0.0,SIGN(1.0,-old_a_i(ji,jj,jl))) !0 if no ice and 1 if yes
+               zindb             = 1.0-MAX(0.0,SIGN(1.0,-old_a_i(ji,jj,jl)+epsi10)) !0 if no ice and 1 if yes
                zht_i_o(ji,jj,jl) = old_v_i(ji,jj,jl) / MAX(old_a_i(ji,jj,jl),epsi10) * zindb
                IF( a_i(ji,jj,jl) > 1e-6 )   zdhice(ji,jj,jl) = ht_i(ji,jj,jl) - zht_i_o(ji,jj,jl) 
@@ -405,5 +438,5 @@
                      * a_i(zji,zjj,klbnd) / ( a_i(zji,zjj,klbnd) - zda0 )
                   a_i(zji,zjj,klbnd)  = a_i(zji,zjj,klbnd) - zda0
-                  v_i(zji,zjj,klbnd)  = a_i(zji,zjj,klbnd)*ht_i(zji,zjj,klbnd)
+                  v_i(zji,zjj,klbnd)  = a_i(zji,zjj,klbnd)*ht_i(zji,zjj,klbnd) ! clem@useless
                ENDIF     ! zetamax > 0
                ! ji, a_i > epsi10
@@ -499,5 +532,5 @@
             a_i(zji,zjj,1)  = a_i(zji,zjj,1) * ht_i(zji,zjj,1) / zhimin 
             ht_i(zji,zjj,1) = zhimin
-            v_i(zji,zjj,1)  = a_i(zji,zjj,1)*ht_i(zji,zjj,1)
+            v_i(zji,zjj,1)  = a_i(zji,zjj,1)*ht_i(zji,zjj,1) !clem@useless
          ENDIF
       END DO !ji
@@ -859,5 +892,5 @@
                   ht_i(ji,jj,jl)  =  v_i   (ji,jj,jl) / a_i(ji,jj,jl) 
                   t_su(ji,jj,jl)  =  zaTsfn(ji,jj,jl) / a_i(ji,jj,jl) 
-                  zindsn          =  1.0 - MAX(0.0,SIGN(1.0,-v_s(ji,jj,jl))) !0 if no ice and 1 if yes
+                  zindsn          =  1.0 - MAX(0.0,SIGN(1.0,-v_s(ji,jj,jl)+epsi10)) !0 if no ice and 1 if yes
                ELSE
                   ht_i(ji,jj,jl)  = 0._wp
@@ -968,4 +1001,10 @@
                   zdaice(ji,jj,jl)  = a_i(ji,jj,jl)
                   zdvice(ji,jj,jl)  = v_i(ji,jj,jl)
+                  ! begin TECLIM change
+                  ! zdaice(ji,jj,jl)  = a_i(ji,jj,jl) 
+                  ! zdvice(ji,jj,jl)  = v_i(ji,jj,jl)
+                  zdaice(ji,jj,jl)  = a_i(ji,jj,jl)/2
+                  zdvice(ji,jj,jl)  = v_i(ji,jj,jl)-zdaice(ji,jj,jl)*(hi_max(jl)+hi_max(jl-1))/2
+                  ! end TECLIM change 
                ENDIF
             END DO                 ! ji
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limrhg.F90	(revision 3938)
@@ -35,4 +35,9 @@
    USE dom_ice_2        ! LIM2: ice domain
 #endif
+   USE lib_fortran      ! to use key_nosignedzero
+
+#if defined key_bdy
+   USE bdyice_lim
+#endif
 
    IMPLICIT NONE
@@ -43,4 +48,5 @@
    REAL(wp) ::   rzero   = 0._wp   ! constant values
    REAL(wp) ::   rone    = 1._wp   ! constant values
+   REAL(wp) ::   epsi20  = 1.e-20_wp   ! constant values
       
    !! * Substitutions
@@ -189,5 +195,5 @@
 #endif
             ! tmi = 1 where there is ice or on land
-            tmi(ji,jj)    = 1._wp - ( 1._wp - MAX( 0._wp , SIGN ( 1._wp , vt_i(ji,jj) - epsd ) ) ) * tms(ji,jj)
+            tmi(ji,jj)    = 1._wp - ( 1._wp - MAX( 0._wp , SIGN ( 1._wp , vt_i(ji,jj) ) ) ) * tms(ji,jj)
          END DO
       END DO
@@ -569,4 +575,9 @@
 
          ENDIF
+         
+!#if defined key_bdy
+!         ! clem: change u_ice and v_ice at the boundary for each iteration
+!         CALL bdy_ice_lim_dyn()
+!#endif         
 
          IF(ln_ctl) THEN
@@ -580,14 +591,14 @@
          ENDIF
 
-         !                                                   ! ==================== !
+         !                                                ! ==================== !
       END DO                                              !  end loop over jter  !
       !                                                   ! ==================== !
-
       !
       !------------------------------------------------------------------------------!
       ! 4) Prevent ice velocities when the ice is thin
       !------------------------------------------------------------------------------!
-      !
-      ! If the ice thickness is below 1cm then ice velocity should equal the
+      !clem : add hminrhg in the namelist
+      !
+      ! If the ice thickness is below hminrhg (5cm) then ice velocity should equal the
       ! ocean velocity, 
       ! This prevents high velocity when ice is thin
@@ -598,5 +609,5 @@
             zindb  = MAX( 0.0, SIGN( 1.0, at_i(ji,jj) - 1.0e-6 ) ) 
             zdummy = zindb * vt_i(ji,jj) / MAX(at_i(ji,jj) , 1.0e-06 )
-            IF ( zdummy .LE. 5.0e-2 ) THEN
+            IF ( zdummy .LE. hminrhg ) THEN
                u_ice(ji,jj) = u_oce(ji,jj)
                v_ice(ji,jj) = v_oce(ji,jj)
@@ -607,4 +618,9 @@
       CALL lbc_lnk( u_ice(:,:), 'U', -1. ) 
       CALL lbc_lnk( v_ice(:,:), 'V', -1. ) 
+
+      ! clem: change u_ice and v_ice at the boundary
+#if defined key_bdy
+      CALL bdy_ice_lim_dyn()
+#endif         
 
       DO jj = k_j1+1, k_jpj-1 
@@ -612,5 +628,5 @@
             zindb  = MAX( 0.0, SIGN( 1.0, at_i(ji,jj) - 1.0e-6 ) ) 
             zdummy = zindb * vt_i(ji,jj) / MAX(at_i(ji,jj) , 1.0e-06 )
-            IF ( zdummy .LE. 5.0e-2 ) THEN
+            IF ( zdummy .LE. hminrhg ) THEN
                v_ice1(ji,jj)  = 0.5*( (v_ice(ji,jj)+v_ice(ji,jj-1))*e1t(ji+1,jj)   &
                   &                 +(v_ice(ji+1,jj)+v_ice(ji+1,jj-1))*e1t(ji,jj)) &
@@ -637,5 +653,5 @@
             zdummy = zindb * vt_i(ji,jj) / MAX(at_i(ji,jj) , 1.0e-06 )
 
-            IF ( zdummy .LE. 5.0e-2 ) THEN
+            IF ( zdummy .LE. hminrhg ) THEN
 
                zdd(ji,jj) = ( e2u(ji,jj)*u_ice(ji,jj)                      &
@@ -692,5 +708,14 @@
             divu_i (ji,jj) = zdd   (ji,jj)
             delta_i(ji,jj) = deltat(ji,jj)
-            shear_i(ji,jj) = zds   (ji,jj)
+            ! begin TECLIM change 
+            ! shear_i(ji,jj) = zds   (ji,jj)
+            zdst       = (  e2u( ji  , jj   ) * v_ice1(ji,jj)           &   
+               &          - e2u( ji-1, jj   ) * v_ice1(ji-1,jj)         &   
+               &          + e1v( ji  , jj   ) * u_ice2(ji,jj)           &   
+               &          - e1v( ji  , jj-1 ) * u_ice2(ji,jj-1)         &   
+               &          )                                             &   
+               &         / area(ji,jj) 
+            shear_i(ji,jj) = SQRT( zdt(ji,jj)*zdt(ji,jj) + zdst*zdst )
+            ! end TECLIM change
          END DO
       END DO
@@ -699,5 +724,6 @@
       CALL lbc_lnk( divu_i (:,:), 'T', 1. )
       CALL lbc_lnk( delta_i(:,:), 'T', 1. )
-      CALL lbc_lnk( shear_i(:,:), 'F', 1. )
+      ! CALL lbc_lnk( shear_i(:,:), 'F', 1. )
+      CALL lbc_lnk( shear_i(:,:), 'T', 1. )
 
       ! * Store the stress tensor for the next time step
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limrst.F90	(revision 3938)
@@ -25,4 +25,5 @@
    USE lib_mpp          ! MPP library
    USE wrk_nemo         ! work arrays
+   USE lib_fortran      ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
 
    IMPLICIT NONE
@@ -161,4 +162,6 @@
       CALL iom_rstput( iter, nitrst, numriw, 'v_ice'     , v_ice      )
       CALL iom_rstput( iter, nitrst, numriw, 'fsbbq'     , fsbbq      )
+      CALL iom_rstput( iter, nitrst, numriw, 'iatte'     , iatte      ) ! clem modif
+      CALL iom_rstput( iter, nitrst, numriw, 'oatte'     , oatte      ) ! clem modif
       CALL iom_rstput( iter, nitrst, numriw, 'stress1_i' , stress1_i  )
       CALL iom_rstput( iter, nitrst, numriw, 'stress2_i' , stress2_i  )
@@ -339,9 +342,9 @@
       !Control of date
 
-      IF( ( nit000 - INT(ziter) ) /= 1 .AND. ABS( nrstdt ) == 1 )   &
+      IF( ( nit000 - NINT(ziter) ) /= 1 .AND. ABS( nrstdt ) == 1 )   &
          &     CALL ctl_stop( 'lim_rst_read ===>>>> : problem with nit000 in ice restart',  &
          &                   '   verify the file or rerun with the value 0 for the',        &
          &                   '   control of time parameter  nrstdt' )
-      IF( INT(zfice) /= nn_fsbc          .AND. ABS( nrstdt ) == 1 )   &
+      IF( NINT(zfice) /= nn_fsbc          .AND. ABS( nrstdt ) == 1 )   &
          &     CALL ctl_stop( 'lim_rst_read ===>>>> : problem with nn_fsbc in ice restart',  &
          &                   '   verify the file or rerun with the value 0 for the',         &
@@ -436,4 +439,6 @@
       CALL iom_get( numrir, jpdom_autoglo, 'v_ice'     , v_ice      )
       CALL iom_get( numrir, jpdom_autoglo, 'fsbbq'     , fsbbq      )
+      CALL iom_get( numrir, jpdom_autoglo, 'iatte'     , iatte      ) ! clem modif
+      CALL iom_get( numrir, jpdom_autoglo, 'oatte'     , oatte      ) ! clem modif
       CALL iom_get( numrir, jpdom_autoglo, 'stress1_i' , stress1_i  )
       CALL iom_get( numrir, jpdom_autoglo, 'stress2_i' , stress2_i  )
@@ -562,5 +567,5 @@
       END DO
       !
-      CALL iom_close( numrir )
+      !clem CALL iom_close( numrir )
       !
       CALL wrk_dealloc( nlay_i, zs_zero )
